import { ViewBase } from '../../libappbase/viewbase';
import { ButtonFinancesContextMenuItem } from '../actionbarpages/abp.data';
import { AppMP } from '../appmp';
import { FormInventoryAccounts } from '../forms/form.inventoryaccounts';
import { FormInventoryCostPISP } from '../forms/form.inventorycostpisp';
import { FormInventoryCosts } from '../forms/form.inventorycosts';

/**
 * Data > Finances > Inventory Costs view.
 */
export class ViewInventoryCosts extends ViewBase {
  public readonly name = 'Inventory Costs';
  public readonly viewPath = 'Data > Finances > Inventory Costs';

  public frmInventoryAccounts = new FormInventoryAccounts();
  public frmInventoryCostPISP = new FormInventoryCostPISP();
  public frmInventoryCosts = new FormInventoryCosts();

  /**
   * Switch to Inventory cost view
   */
  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();

    // wait until abp develop is visible
    await appMP.abpData.isVisible();
    // Open Develop action bar page
    await appMP.abpData.click();
    // Click on Inventory Cost button
    await appMP.abpData.btnFinances.clickDropdownAndSelectMenu(ButtonFinancesContextMenuItem.InventoryCosts);
    // Wait until form inventory account, inventory cost and inventory cost pisp is present
    await this.frmInventoryAccounts.waitUntilPresent();
    await this.frmInventoryCostPISP.waitUntilPresent();
    await this.frmInventoryCosts.waitUntilPresent();
  }
}
